#include "histogram.h"
#include <vector>
#include <iostream>
using namespace std;

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
                max = x;
        }
    }
}

vector<double>
make_histogram(const vector<double>& numbers, size_t bin_count){
    vector<double> bins (bin_count);

    double min = 0, max = 0;
    find_minmax(numbers, min, max);

    double bin_size = (max - min) / bin_count;
    for (int i = 0; i < numbers.size(); i++) {
            bool found = false;
            for (int j = 0; (j < bin_count - 1) && !found; j++) {
                auto lo = min + j * bin_size;
                auto hi = min + (j + 1) * bin_size;
                if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                    bins[j]++;
                    found = true;
                }
            }
            if (!found) {
                bins[bin_count - 1]++;
            }
    }
    return bins;
}
