#include <curl/curl.h>
#include <vector>
#include <iostream>
#include <string>
#include "histogram.h"
#include "text.h"
#include "svg.h"
using namespace std;
struct Input {
    vector<double> numbers;
    size_t bin_count {};
};

Input
input_data(istream& in, bool prompt) {
    size_t number_count;
    if (prompt) {cerr << "Enter number count: ";};
    in >> number_count;

    Input in1;
    in1.numbers.resize(number_count);
    if (prompt) {cerr << "Enter numbers: ";};
    for (size_t i = 0; i < number_count; i++) {
        in >> in1.numbers[i];
    }


    if (prompt) {cerr << "Enter bin count: ";};
    in >> in1.bin_count;

    return in1;
}

int main()
{
    #include <curl/curl.h>
    curl_global_init(CURL_GLOBAL_ALL);
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    bool prompt = true;

    auto in = input_data(cin, prompt);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);
    return 0;
}
